paramikojs.rng_win32 = {};

paramikojs.rng_win32._RNG = function () {
  this.rng = new crypto.random.OSRNG.WindowsRNG();
}

paramikojs.rng_win32._RNG.prototype = {
  read : function(N, dontFlush) {
    return this.rng.read(N, dontFlush);
  },

	randomize : function() {
    // According to "Cryptanalysis of the Random Number Generator of the
    // Windows Operating System", by Leo Dorrendorf and Zvi Gutterman
    // and Benny Pinkas <http://eprint.iacr.org/2007/419>,
    // CryptGenRandom only updates its internal state using kernel-provided
    // random data every 128KiB of output.
    this.rng.flush();  // discard 128 KiB of output
  }
};

paramikojs.rng_win32.open_rng_device = function() {
	return new paramikojs.rng_win32._RNG();
};
